/* random sampling */

#ifndef SAMPLE_H
#define SAMPLE_H

/* sample from a discrete distribution */
template <class T>
int sample(T *dist, int length) {
  if (length == 1)
    return 0;

  int middle = length/2;
  double a = 0;
  double b = 0;
  for (int i = 0; i < middle; i++)
    a += dist[i];
  for (int i = middle; i < length; i++)
    b += dist[i];

  double r = drand48();
  if (r*(a+b) < a)
    return sample(dist, middle);
  else
    return middle+sample(dist+middle, length-middle);
}

#endif
