/*
 * This program loads a grayscale image from a file "input.pgm" and 
 * draws a white cross in the center of this image.  The output is saved 
 * to "output.pgm".
 * 
 * Modify the program so it draws a rectangle instead of a cross.  
 */

#include "image.h"
#include "pnmfile.h"

/* size of the cross */
#define SIZE 10

int main() {

  /* load image */
  image<uchar> *input = loadPGM("input.pgm");

  /* compute the center of the image */
  int center_x = input->width()/2;
  int center_y = input->height()/2;

  /* draw a white cross in the center */
  for (int x = -SIZE; x <= SIZE; x++)
    imRef(input, center_x + x, center_y) = 255;

  for (int y = -SIZE; y <= SIZE; y++)
    imRef(input, center_x, center_y + y) = 255;

  /* save image */
  savePGM(input, "output.pgm");
}
